/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessengerSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessengerSettings{}

// MessengerSettings struct for MessengerSettings
type MessengerSettings struct {
	Name *string `json:"name,omitempty"`
	Description *string `json:"description,omitempty"`
	ShortDescription *string `json:"short_description,omitempty"`
	ProfilePhoto *MessengerSettingsProfilePhoto `json:"profile_photo,omitempty"`
	// Available only in `instagram` gateway type.
	IceBreakers []IceBreaker `json:"ice_breakers,omitempty"`
	// Available only in `FacebookMessenger` gateway type
	Greeting []LocalizedText `json:"greeting,omitempty"`
	GetStarted *string `json:"get_started,omitempty"`
	MessengerUrl *string `json:"messenger_url,omitempty"`
	ProfileUrl *string `json:"profile_url,omitempty"`
	BusinessProfile *MessengerBusinessProfile `json:"business_profile,omitempty"`
}

// NewMessengerSettings instantiates a new MessengerSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessengerSettings() *MessengerSettings {
	this := MessengerSettings{}
	return &this
}

// NewMessengerSettingsWithDefaults instantiates a new MessengerSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessengerSettingsWithDefaults() *MessengerSettings {
	this := MessengerSettings{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *MessengerSettings) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *MessengerSettings) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *MessengerSettings) SetName(v string) {
	o.Name = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *MessengerSettings) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *MessengerSettings) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *MessengerSettings) SetDescription(v string) {
	o.Description = &v
}

// GetShortDescription returns the ShortDescription field value if set, zero value otherwise.
func (o *MessengerSettings) GetShortDescription() string {
	if o == nil || IsNil(o.ShortDescription) {
		var ret string
		return ret
	}
	return *o.ShortDescription
}

// GetShortDescriptionOk returns a tuple with the ShortDescription field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetShortDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.ShortDescription) {
		return nil, false
	}
	return o.ShortDescription, true
}

// HasShortDescription returns a boolean if a field has been set.
func (o *MessengerSettings) HasShortDescription() bool {
	if o != nil && !IsNil(o.ShortDescription) {
		return true
	}

	return false
}

// SetShortDescription gets a reference to the given string and assigns it to the ShortDescription field.
func (o *MessengerSettings) SetShortDescription(v string) {
	o.ShortDescription = &v
}

// GetProfilePhoto returns the ProfilePhoto field value if set, zero value otherwise.
func (o *MessengerSettings) GetProfilePhoto() MessengerSettingsProfilePhoto {
	if o == nil || IsNil(o.ProfilePhoto) {
		var ret MessengerSettingsProfilePhoto
		return ret
	}
	return *o.ProfilePhoto
}

// GetProfilePhotoOk returns a tuple with the ProfilePhoto field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetProfilePhotoOk() (*MessengerSettingsProfilePhoto, bool) {
	if o == nil || IsNil(o.ProfilePhoto) {
		return nil, false
	}
	return o.ProfilePhoto, true
}

// HasProfilePhoto returns a boolean if a field has been set.
func (o *MessengerSettings) HasProfilePhoto() bool {
	if o != nil && !IsNil(o.ProfilePhoto) {
		return true
	}

	return false
}

// SetProfilePhoto gets a reference to the given MessengerSettingsProfilePhoto and assigns it to the ProfilePhoto field.
func (o *MessengerSettings) SetProfilePhoto(v MessengerSettingsProfilePhoto) {
	o.ProfilePhoto = &v
}

// GetIceBreakers returns the IceBreakers field value if set, zero value otherwise.
func (o *MessengerSettings) GetIceBreakers() []IceBreaker {
	if o == nil || IsNil(o.IceBreakers) {
		var ret []IceBreaker
		return ret
	}
	return o.IceBreakers
}

// GetIceBreakersOk returns a tuple with the IceBreakers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetIceBreakersOk() ([]IceBreaker, bool) {
	if o == nil || IsNil(o.IceBreakers) {
		return nil, false
	}
	return o.IceBreakers, true
}

// HasIceBreakers returns a boolean if a field has been set.
func (o *MessengerSettings) HasIceBreakers() bool {
	if o != nil && !IsNil(o.IceBreakers) {
		return true
	}

	return false
}

// SetIceBreakers gets a reference to the given []IceBreaker and assigns it to the IceBreakers field.
func (o *MessengerSettings) SetIceBreakers(v []IceBreaker) {
	o.IceBreakers = v
}

// GetGreeting returns the Greeting field value if set, zero value otherwise.
func (o *MessengerSettings) GetGreeting() []LocalizedText {
	if o == nil || IsNil(o.Greeting) {
		var ret []LocalizedText
		return ret
	}
	return o.Greeting
}

// GetGreetingOk returns a tuple with the Greeting field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetGreetingOk() ([]LocalizedText, bool) {
	if o == nil || IsNil(o.Greeting) {
		return nil, false
	}
	return o.Greeting, true
}

// HasGreeting returns a boolean if a field has been set.
func (o *MessengerSettings) HasGreeting() bool {
	if o != nil && !IsNil(o.Greeting) {
		return true
	}

	return false
}

// SetGreeting gets a reference to the given []LocalizedText and assigns it to the Greeting field.
func (o *MessengerSettings) SetGreeting(v []LocalizedText) {
	o.Greeting = v
}

// GetGetStarted returns the GetStarted field value if set, zero value otherwise.
func (o *MessengerSettings) GetGetStarted() string {
	if o == nil || IsNil(o.GetStarted) {
		var ret string
		return ret
	}
	return *o.GetStarted
}

// GetGetStartedOk returns a tuple with the GetStarted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetGetStartedOk() (*string, bool) {
	if o == nil || IsNil(o.GetStarted) {
		return nil, false
	}
	return o.GetStarted, true
}

// HasGetStarted returns a boolean if a field has been set.
func (o *MessengerSettings) HasGetStarted() bool {
	if o != nil && !IsNil(o.GetStarted) {
		return true
	}

	return false
}

// SetGetStarted gets a reference to the given string and assigns it to the GetStarted field.
func (o *MessengerSettings) SetGetStarted(v string) {
	o.GetStarted = &v
}

// GetMessengerUrl returns the MessengerUrl field value if set, zero value otherwise.
func (o *MessengerSettings) GetMessengerUrl() string {
	if o == nil || IsNil(o.MessengerUrl) {
		var ret string
		return ret
	}
	return *o.MessengerUrl
}

// GetMessengerUrlOk returns a tuple with the MessengerUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetMessengerUrlOk() (*string, bool) {
	if o == nil || IsNil(o.MessengerUrl) {
		return nil, false
	}
	return o.MessengerUrl, true
}

// HasMessengerUrl returns a boolean if a field has been set.
func (o *MessengerSettings) HasMessengerUrl() bool {
	if o != nil && !IsNil(o.MessengerUrl) {
		return true
	}

	return false
}

// SetMessengerUrl gets a reference to the given string and assigns it to the MessengerUrl field.
func (o *MessengerSettings) SetMessengerUrl(v string) {
	o.MessengerUrl = &v
}

// GetProfileUrl returns the ProfileUrl field value if set, zero value otherwise.
func (o *MessengerSettings) GetProfileUrl() string {
	if o == nil || IsNil(o.ProfileUrl) {
		var ret string
		return ret
	}
	return *o.ProfileUrl
}

// GetProfileUrlOk returns a tuple with the ProfileUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetProfileUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ProfileUrl) {
		return nil, false
	}
	return o.ProfileUrl, true
}

// HasProfileUrl returns a boolean if a field has been set.
func (o *MessengerSettings) HasProfileUrl() bool {
	if o != nil && !IsNil(o.ProfileUrl) {
		return true
	}

	return false
}

// SetProfileUrl gets a reference to the given string and assigns it to the ProfileUrl field.
func (o *MessengerSettings) SetProfileUrl(v string) {
	o.ProfileUrl = &v
}

// GetBusinessProfile returns the BusinessProfile field value if set, zero value otherwise.
func (o *MessengerSettings) GetBusinessProfile() MessengerBusinessProfile {
	if o == nil || IsNil(o.BusinessProfile) {
		var ret MessengerBusinessProfile
		return ret
	}
	return *o.BusinessProfile
}

// GetBusinessProfileOk returns a tuple with the BusinessProfile field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerSettings) GetBusinessProfileOk() (*MessengerBusinessProfile, bool) {
	if o == nil || IsNil(o.BusinessProfile) {
		return nil, false
	}
	return o.BusinessProfile, true
}

// HasBusinessProfile returns a boolean if a field has been set.
func (o *MessengerSettings) HasBusinessProfile() bool {
	if o != nil && !IsNil(o.BusinessProfile) {
		return true
	}

	return false
}

// SetBusinessProfile gets a reference to the given MessengerBusinessProfile and assigns it to the BusinessProfile field.
func (o *MessengerSettings) SetBusinessProfile(v MessengerBusinessProfile) {
	o.BusinessProfile = &v
}

func (o MessengerSettings) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessengerSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.ShortDescription) {
		toSerialize["short_description"] = o.ShortDescription
	}
	if !IsNil(o.ProfilePhoto) {
		toSerialize["profile_photo"] = o.ProfilePhoto
	}
	if !IsNil(o.IceBreakers) {
		toSerialize["ice_breakers"] = o.IceBreakers
	}
	if !IsNil(o.Greeting) {
		toSerialize["greeting"] = o.Greeting
	}
	if !IsNil(o.GetStarted) {
		toSerialize["get_started"] = o.GetStarted
	}
	if !IsNil(o.MessengerUrl) {
		toSerialize["messenger_url"] = o.MessengerUrl
	}
	if !IsNil(o.ProfileUrl) {
		toSerialize["profile_url"] = o.ProfileUrl
	}
	if !IsNil(o.BusinessProfile) {
		toSerialize["business_profile"] = o.BusinessProfile
	}
	return toSerialize, nil
}

type NullableMessengerSettings struct {
	value *MessengerSettings
	isSet bool
}

func (v NullableMessengerSettings) Get() *MessengerSettings {
	return v.value
}

func (v *NullableMessengerSettings) Set(val *MessengerSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableMessengerSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableMessengerSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessengerSettings(val *MessengerSettings) *NullableMessengerSettings {
	return &NullableMessengerSettings{value: val, isSet: true}
}

func (v NullableMessengerSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessengerSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


